﻿function displayMessage(msg)
	inInstance, instanceType = IsInInstance()

	local messageType = "SAY"

	if AnnouncerSay==true then
		--
	elseif inInstance == 1 and instanceType ~= "none" then
		messageType = "INSTANCE_CHAT"
	end

	if (AnnouncerRW == true and (UnitIsGroupAssistant("player") or UnitIsGroupLeader("player")) and IsInRaid()) then
		messageType = "RAID_WARNING"
	end
	
	SendChatMessage(msg,messageType)
end

function printMessage(msg)
	print("|cff7f7fff[Conjured Announcer] "..msg)
end

function OnEvent(self, event, ...)
	if event == "VARIABLES_LOADED" then
	
		if AnnouncerState==nil then
			AnnouncerState = true
		end

		if AnnouncerSay==nil then
			AnnouncerSay = true
		end
		if AnnouncerRW==nil then
			AnnouncerRW = false
		end		
		
		if AnnouncerState==true then
			conjuredAnnouncer:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		else
			conjuredAnnouncer:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		end
		
		printMessage("Kekk's Conjured Announcer loaded.")
		printMessage("Type /can or /cann for options. Announcer stats is: "..getState(AnnouncerState))
			
		SlashCmdList["FFDCMD"] = SlashCommand;
		SLASH_FFDCMD1 = "/can";
		SLASH_FFDCMD2 = "/cann";
	else
		local timestamp, type, sourceGUID,hideCaster, sourceName, sourceFlags,sourceRaidFlags, destGUID, destName, destFlags,destRaidFlags, spellID, spellName = select(1, ...)
		
		--print (type,spellID,sourceName,destName)
		--printMessage (searchTable)

		if (AnnouncerState == true and (UnitInParty(sourceName) or UnitInRaid(sourceName)) and (type=="SPELL_CREATE" or type=="SPELL_SUMMON" or type=="SPELL_CAST_START") and GetNumGroupMembers()>0 and checkTable[spellID]~=nil) then
			--printMessage ("**************")
			--printMessage (type,spellID,sourceName,destName)
			
			-- use this for cauldrons, they show up only for SPELL_CAST_START and have null for destName
			if (destName==nil) then
				destName = spellName
			end

			
			if (destName=="Create Soulwell") then
				return
			end
			
			message     = ">>> " ..sourceName .. " creates " .. destName.." <<<"
			

			
			if (antispamtable[message]==nil) then
				antispamtable[message] = time()
				displayMessage(message)
			else			
				if (time()-antispamtable[message])>10 then
					antispamtable[message] = time()
					displayMessage(message)
				end
			end
		end
	end
end

function helptxt()
	printMessage(" Kekk's Conjured Announcer. Current state: "..getState(AnnouncerState))
	printMessage(" ")	
	printMessage(" Activeate : /can on")
	printMessage(" Deactivate: /can off")
	printMessage(" Announce on SAY: /can say")
	printMessage(" Announce on group chat: /can group")
	printMessage(" Announce on raid warning: /can rw")
end

function SlashCommand(msg)
	local argc, argv = 0, {}
	gsub(msg, "[^%s]+", function (word) argc=argc+1; argv[argc]=word; end);

	if (argc == 1) then
		if (argv[1] == "help") then
			helptxt()
		elseif (argv[1] == "off") then
			printMessage("Announcer state OFF. Type /can on to activate")
			AnnouncerState = false;		
			conjuredAnnouncer:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		elseif  (argv[1] == "on") then
			printMessage("Announcer state ON. Type /can off to deactivate")
			AnnouncerState = true
			conjuredAnnouncer:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		elseif  (argv[1] == "say") then
			AnnouncerSay = true
			printMessage("Announcer set to SAY.")
		elseif  (argv[1] == "rw") then
			AnnouncerRW = not AnnouncerRW
			printMessage("Announcer using raidwarning: "..getState(AnnouncerRW))
		elseif  (argv[1] == "group") then
			AnnouncerSay = false
			printMessage("Announcer set to GROUP.")			
		end
	else
		helptxt()
	end
end

function getState(cond)
	if cond==true then
		return "ON"	
	else
		return "OFF"
	end
end

	
--67826 Jeeves
--54711 Scrapbot
--44389 Field Repair Bot 110G
--57426 Fish Feast
--57301 great feast
--54710 MOLL-E
--127129 Blingtron 4000

--92824 Ritual of Refreshment
--43987 Refreshment Portal
--698   Ritual of Summoning
--29893 Ritual of Souls
-- 126135 Lightwell

--92649 Cauldron of Battle
--92712 Big Cauldron of Battle
--87915 Goblin Barbecue Feast
--87644 Seafood Magnifique Feast
--87643 Broiled Dragon Feast

--146936 Noodle Cart
--146937 Deluxe Noodle Cart
--146938 Pandaren Treasure Noodle Cart

--104958 Pandaren Banquet
--126492 Banquet of the Grill
--126494 Great Banquet of the Grill
--126501 Banquet of the Oven
--126502 Great Banquet of the Oven
--126504 Great Banquet of the Brew
--126498 Great Banquet of the Pot
--126500 Great Banquet of the Steamer
--126496 Great Banquet of the Wok
--105193 Great Pandaren Banquet
--126503 Banquet of the Brew
--126497 Banquet of the Pot
--126499 Banquet of the Steamer
--126495 Banquet of the Wok

--10059 Stormwind Portal
--11416 Ironforge Portal
--11417 Ogrimmar Portal
--11418 Undercity Portal
--11419 Darnassus Portal
--11420 Thunder Bluff Portal
--32266 Exodar Portal
--32267 Silvermoon Portal
--33691 SHATTRATH Portal
--35717 Shattrath Portal
--49360 Theramore Portal
--49361 Stonard Portal
--53142 Dalaran Portal
--88345 Tol Barad Portal
--88346 Tol Barad Portal
--120146 Ancient Dalaran Portal
--132620 VALE OF ETERNAL BLOSSOMS PORTAL
--132626 VALE OF ETERNAL BLOSSOMS PORTAL

spellIDS   = {67826,54711,44389,57426,57301,54710,127129,92824,43987,698,29893,126135,92649,92712,87915,87644,87643,146936,146937,146938,104958,126492,126494,126501,126502,126504,126498,126500,126496,105193,126503,126497,126499,126495,10059,11416,11417,11418,11419,11420,32266,32267,33691,35717,49360,49361,53142,88345,88346,120146,132620,132626}
checkTable = {}

for i=1,#spellIDS do checkTable[spellIDS[i]]=1 end

msgType = {}
msgType["pvp"]="BATTLEGROUND"
msgType["arena"]="PARTY"
msgType["party"]="PARTY"
msgType["raid"]="RAID"

antispamtable = {}



conjuredAnnouncer = CreateFrame("Frame")
conjuredAnnouncer:RegisterEvent("VARIABLES_LOADED")
conjuredAnnouncer:SetScript("OnEvent", OnEvent)

